<?php
class Wpmc_PiwikAnalytics
{

    public function __construct()
    {
        add_action('admin_menu', array($this, 'menu'));
        add_action('admin_action_save_piwik', array($this, 'save_piwik'));
        add_filter( 'woocommerce_integrations', array($this,'wc_piwik_add_integration' ));
        add_action( 'wp_footer', array( $this, 'spool_analytics' ) );
    }

    public function menu()
    {
        add_menu_page(__('Campaigns.io', 'wpmc'), __('Campaigns.io', 'wpmc'), 'manage_options', 'wpmc-setting', array($this, 'piwik_setting'));
    }

    public function piwik_setting()
    {
        $settings = get_option('wpmc_piwik_setting');
        $api_settings = get_option('wpmc_api_setting');

        echo $this->render('piwik_settings', array('settings' => $settings, 'api_settings' => $api_settings));
    }


    public function wc_piwik_add_integration( $integrations ) {

    	global $woocommerce;

    	if ( is_object( $woocommerce ) && version_compare( $woocommerce->version, '2.1-beta-1', '>=' ) ) {

    		include_once( 'class-wc-piwik.php');
    		$integrations[] = 'Wpmc_woo_Piwik';
    	}

    	return $integrations;
    }



    public function save_piwik()
    {
        $array['piwik_siteid']   = $_POST['piwik_siteid'];
        $array['piwik_hostname'] = $_POST['piwik_hostname'];
        update_option('wpmc_piwik_setting', $array);

        $array_api['wp_login_key'] = $_POST['wp_login_key'];
        $array_api['wp_login_secret'] = $_POST['wp_login_secret'];
        update_option('wpmc_api_setting', $array_api);

        add_action('admin_notices', array($this, 'save_success_message'));
        wp_redirect('admin.php?page=wpmc-setting');

    }

    public function save_success_message()
    {
        ?>
		<div class="notice notice-success is-dismissible">
		       <p><?php _e('Saved!', '');?></p>
		   </div>
<?php
}

    public static function render($view, $data = null)
    {
        // Handle data
        ($data) ? extract($data) : null;

        ob_start();
        include plugin_dir_path(__FILE__) . '../views/' . $view . '.php';
        $view = ob_get_contents();
        ob_end_clean();

        return $view;
    }

    public function spool_analytics() {
			?><?php
			if(!is_admin()) {
			$options  = get_option('wpmc_piwik_setting');
            $options['piwik_hostname'] = ($options['piwik_hostname'])?$options['piwik_hostname']:'analytics.campaigns.io/matomo.php';
            $domain_name = $_SERVER['HTTP_HOST'];
			?>

			<script type="text/javascript">
  var _paq = window._paq = window._paq || [];
  /* tracker methods like "setCustomDimension" should be called before "trackPageView" */
  _paq.push(['trackPageView']);
  _paq.push(['enableLinkTracking']);
  (function() {
    var u="//<?php echo esc_js( $options['piwik_hostname'] ); ?>/";
    _paq.push(['setTrackerUrl', u+'matomo.php']);
    _paq.push(['setSiteId', <?php echo esc_js($options['piwik_siteid']); ?>]);
    var d=document, g=d.createElement('script'), s=d.getElementsByTagName('script')[0];
    g.type='text/javascript'; g.async=true; g.src=u+'matomo.js'; s.parentNode.insertBefore(g,s);
  })();
</script>
			<noscript>
				<p>
					<img
                        src="//<?php echo esc_js( $options['piwik_hostname'] ); ?>/matomo.php?idsite=<?php echo esc_js($options['piwik_siteid'] ); ?>"
                        style="border:0;" alt=""/>
				</p>
			</noscript>
		<?php
					}
			}

}
