<?php
class Wpmc_Rsa_Handler {

	private static $rsa;
	private static $public_key;
	private static $private_key;
	private static $key_pair;
	private static function init() {

		if (!function_exists('sodium_crypto_sign_keypair')) {
			require_once WPMC_INCLUDES_PATH . '/../vendor/autoload.php';
		}
		$api_settings = get_option('wpmc_api_setting');

		self::$private_key = base64_decode($api_settings['wp_login_secret']);
		self::$public_key = base64_decode($api_settings['wp_login_key']);
	}

	public static function sign($package) {
		self::init();
		return "";
	}

	public static function verify($package, $signature) {
		self::init();
		return true;
	}

	public static function encrypt($package) {
		self::init();
		return sodium_crypto_sign(
			$package,
			self::$private_key
		);
	}

	public static function decrypt($package) {
		self::init();
		return sodium_crypto_sign_open(
			$package,
			self::$public_key
		);
	}
}